package com.clx.performance.dao.impl.customer;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.clx.performance.dao.customer.CustomerComplaintDetailDao;
import com.clx.performance.mapper.customer.CustomerComplaintDetailMapper;
import com.clx.performance.model.customer.CustomerComplaintDetail;
import com.clx.performance.param.pc.customer.PageCustomerComplaintDetailParam;
import com.msl.common.dao.impl.BaseDaoImpl;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Repository;

import java.util.Objects;

/**
 * @ClassName CustomerComplaintTypeDaoImpl
 * @Description
 * @Author kavin
 * @Date 2023/12/7 11:25
 * @Version 1.0
 */
@Repository
public class CustomerComplaintDetailDaoImpl extends BaseDaoImpl<CustomerComplaintDetailMapper, CustomerComplaintDetail, Integer> implements CustomerComplaintDetailDao {
    @Override
    public IPage<CustomerComplaintDetail> pageCustomerComplaintDetail(PageCustomerComplaintDetailParam param) {
        LambdaQueryWrapper<CustomerComplaintDetail> query = new LambdaQueryWrapper<>();
        if(Objects.nonNull(param.getComplaintTypeId())){
            query.eq(CustomerComplaintDetail :: getComplaintTypeId,param.getComplaintTypeId());
        }
        if(StringUtils.isNotBlank(param.getChildNo())){
            query.eq(CustomerComplaintDetail :: getChildNo,param.getChildNo());
        }

        if(StringUtils.isNotBlank(param.getDriverMobile())){
            query.eq(CustomerComplaintDetail :: getDriverMobile,param.getDriverMobile());
        }

        if(StringUtils.isNotBlank(param.getDriverName())){
            query.eq(CustomerComplaintDetail :: getDriverName,param.getDriverName());
        }

        if(StringUtils.isNotBlank(param.getBeginTime())){
            query.ge(CustomerComplaintDetail :: getCreateTime,param.getBeginTime());
        }
        if(StringUtils.isNotBlank(param.getEndTime())){
            query.le(CustomerComplaintDetail :: getCreateTime,param.getEndTime());
        }
        query.orderByDesc(CustomerComplaintDetail :: getCreateTime);
        return baseMapper.selectPage(Page.of(param.getPage(),param.getPageSize()),query);
    }
}
